package me.km.blocks;

import me.km.items.ModItems;
import net.minecraft.block.BlockState;
import net.minecraft.block.FlowingFluidBlock;
import net.minecraft.fluid.Fluid;
import net.minecraft.fluid.IFluidState;
import net.minecraft.fluid.WaterFluid;
import net.minecraft.item.Item;
import net.minecraft.state.StateContainer;
import net.minecraft.world.IWorldReader;

public abstract class FluidHoney extends WaterFluid
{
    @Override
    public Fluid getFlowingFluid()
    {
        return ModBlocks.FLOWING_HONEY;
    }

    @Override
    public Fluid getStillFluid()
    {
        return ModBlocks.SOURCE_HONEY;
    }

    @Override
    public Item getFilledBucket()
    {
        return ModItems.bucketHoney;
    }

    @Override
    public BlockState getBlockState(IFluidState state)
    {
        return ModBlocks.honey.getDefaultState().with(FlowingFluidBlock.LEVEL, getLevelFromState(state));
    }

    @Override
    public boolean isEquivalentTo(Fluid fluidIn)
    {
        return fluidIn == ModBlocks.SOURCE_HONEY || fluidIn == ModBlocks.FLOWING_HONEY;
    }

    @Override
    public int getLevelDecreasePerBlock(IWorldReader worldIn)
    {
        return 2;
    }

    @Override
    public int getTickRate(IWorldReader p_205569_1_)
    {
        return 20;
    }

    public static class Flowing extends FluidHoney
    {
        @Override
        protected void fillStateContainer(StateContainer.Builder<Fluid, IFluidState> builder)
        {
            super.fillStateContainer(builder);
            builder.add(LEVEL_1_8);
        }

        @Override
        public int getLevel(IFluidState p_207192_1_)
        {
            return p_207192_1_.get(LEVEL_1_8);
        }

        @Override
        public boolean isSource(IFluidState state)
        {
            return false;
        }
    }

    public static class Source extends FluidHoney
    {
        @Override
        public int getLevel(IFluidState state)
        {
            return 8;
        }

        @Override
        public boolean isSource(IFluidState state)
        {
            return true;
        }
    }
}
