package me.km.blocks;

import me.km.items.ModItems;
import net.minecraft.block.BlockState;
import net.minecraft.block.FlowingFluidBlock;
import static net.minecraft.fluid.FlowingFluid.LEVEL_1_8;
import net.minecraft.fluid.Fluid;
import net.minecraft.fluid.IFluidState;
import net.minecraft.fluid.WaterFluid;
import net.minecraft.item.Item;
import net.minecraft.state.StateContainer;

public abstract class FluidPoison extends WaterFluid
{
    @Override
    public Fluid getFlowingFluid()
    {
        return ModBlocks.FLOWING_POISON;
    }

    @Override
    public Fluid getStillFluid()
    {
        return ModBlocks.SOURCE_POISON;
    }

    @Override
    public Item getFilledBucket()
    {
        return ModItems.bucketPoison;
    }

    @Override
    public BlockState getBlockState(IFluidState state)
    {
        return ModBlocks.poison.getDefaultState().with(FlowingFluidBlock.LEVEL, getLevelFromState(state));
    }

    @Override
    public boolean isEquivalentTo(Fluid fluidIn)
    {
        return fluidIn == ModBlocks.SOURCE_POISON || fluidIn == ModBlocks.FLOWING_POISON;
    }

    public static class Flowing extends FluidPoison
    {
        @Override
        protected void fillStateContainer(StateContainer.Builder<Fluid, IFluidState> builder)
        {
            super.fillStateContainer(builder);
            builder.add(LEVEL_1_8);
        }

        @Override
        public int getLevel(IFluidState p_207192_1_)
        {
            return p_207192_1_.get(LEVEL_1_8);
        }

        @Override
        public boolean isSource(IFluidState state)
        {
            return false;
        }
    }

    public static class Source extends FluidPoison
    {
        @Override
        public int getLevel(IFluidState state)
        {
            return 8;
        }

        @Override
        public boolean isSource(IFluidState state)
        {
            return true;
        }
    }
}